Loading...
Searching...
No Matches
juce::CharPointer_UTF32 Class Referencefinal

## Detailed Description

Wraps a pointer to a null-terminated UTF-32 character string, and provides various methods to operate on the data.

See also
  CharPointer_UTF8, CharPointer_UTF16

The documentation for this class was generated from the following file:

- juce_core/text/juce_CharPointer_UTF32.h

## Public Types

using | CharType = juce_wchar

## Public Member Functions

| CharPointer_UTF32 (const CharType *rawPointer) noexcept
| CharPointer_UTF32 (const CharPointer_UTF32 &other)=default
CharPointer_UTF32 & | operator= (const CharPointer_UTF32 &other) noexcept=default
CharPointer_UTF32 & | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_UTF32 other) const noexcept
| This is a pointer comparison, it doesn't compare the actual text.
bool | operator!= (CharPointer_UTF32 other) const noexcept
bool | operator<= (CharPointer_UTF32 other) const noexcept
bool | operator< (CharPointer_UTF32 other) const noexcept
bool | operator>= (CharPointer_UTF32 other) const noexcept
bool | operator> (CharPointer_UTF32 other) const noexcept
CharType * | getAddress () const noexcept
| Returns the address that this pointer is pointing to.
| operator const CharType * () const noexcept
| Returns the address that this pointer is pointing to.
bool | isEmpty () const noexcept
| Returns true if this pointer is pointing to a null character.
bool | isNotEmpty () const noexcept
| Returns true if this pointer is not pointing to a null character.
juce_wchar | operator* () const noexcept
| Returns the unicode character that this pointer is pointing to.
CharPointer_UTF32 & | operator++ () noexcept
| Moves this pointer along to the next character in the string.
CharPointer_UTF32 & | operator-- () noexcept
| Moves this pointer to the previous character in the string.
juce_wchar | getAndAdvance () noexcept
| Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.
CharPointer_UTF32 | operator++ (int) noexcept
| Moves this pointer along to the next character in the string.
CharPointer_UTF32 & | operator+= (int numToSkip) noexcept
| Moves this pointer forwards by the specified number of characters.
CharPointer_UTF32 & | operator-= (int numToSkip) noexcept
juce_wchar & | operator[] (int characterIndex) const noexcept
| Returns the character at a given character index from the start of the string.
CharPointer_UTF32 | operator+ (int numToSkip) const noexcept
| Returns a pointer which is moved forwards from this one by the specified number of characters.
CharPointer_UTF32 | operator- (int numToSkip) const noexcept
| Returns a pointer which is moved backwards from this one by the specified number of characters.
void | write (juce_wchar charToWrite) noexcept
| Writes a unicode character to this string, and advances this pointer to point to the next position.
void | replaceChar (juce_wchar newChar) noexcept
void | writeNull () const noexcept
| Writes a null character to this string (leaving the pointer's position unchanged).
size_t | length () const noexcept
| Returns the number of characters in this string.
size_t | lengthUpTo (size_t maxCharsToCount) const noexcept
| Returns the number of characters in this string, or the given value, whichever is lower.
size_t | lengthUpTo (CharPointer_UTF32 end) const noexcept
| Returns the number of characters in this string, or up to the given end pointer, whichever is lower.
size_t | sizeInBytes () const noexcept
| Returns the number of bytes that are used to represent this string.
CharPointer_UTF32 | findTerminatingNull () const noexcept
| Returns a pointer to the null character that terminates this string.
template<typename CharPointer>
void | writeAll (CharPointer src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
void | writeAll (CharPointer_UTF32 src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
size_t | writeWithDestByteLimit (CharPointer src, size_t maxDestBytes) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
void | writeWithCharLimit (CharPointer src, int maxChars) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
int | compare (CharPointer other) const noexcept
| Compares this string with another one.
template<typename CharPointer>
int | compareUpTo (CharPointer other, int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer>
int | compareIgnoreCase (CharPointer other) const
| Compares this string with another one.
template<typename CharPointer>
int | compareIgnoreCaseUpTo (CharPointer other, int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer>
int | indexOf (CharPointer stringToFind) const noexcept
| Returns the character index of a substring, or -1 if it isn't found.
int | indexOf (juce_wchar charToFind) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
int | indexOf (juce_wchar charToFind, bool ignoreCase) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
bool | isWhitespace () const
| Returns true if the first character of this string is whitespace.
bool | isDigit () const
| Returns true if the first character of this string is a digit.
bool | isLetter () const
| Returns true if the first character of this string is a letter.
bool | isLetterOrDigit () const
| Returns true if the first character of this string is a letter or digit.
bool | isUpperCase () const
| Returns true if the first character of this string is upper-case.
bool | isLowerCase () const
| Returns true if the first character of this string is lower-case.
juce_wchar | toUpperCase () const noexcept
| Returns an upper-case version of the first character of this string.
juce_wchar | toLowerCase () const noexcept
| Returns a lower-case version of the first character of this string.
int | getIntValue32 () const noexcept
| Parses this string as a 32-bit integer.
int64 | getIntValue64 () const noexcept
| Parses this string as a 64-bit integer.
double | getDoubleValue () const noexcept
| Parses this string as a floating point double.
CharPointer_UTF32 | findEndOfWhitespace () const noexcept
| Returns the first non-whitespace character in the string.
void | incrementToEndOfWhitespace () noexcept
| Move this pointer to the first non-whitespace character in the string.
CharPointer_UTF32 | atomicSwap (CharPointer_UTF32 newValue)
| Atomically swaps this pointer for a new value, returning the previous value.

## Static Public Member Functions

static size_t | getBytesRequiredFor (juce_wchar) noexcept
| Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.
template<class CharPointer>
static size_t | getBytesRequiredFor (CharPointer text) noexcept
| Returns the number of bytes that would be needed to represent the given string in this encoding format.
static bool | canRepresent (juce_wchar character) noexcept
| Returns true if the given unicode character can be represented in this encoding.
static bool | isValidString (const CharType *codeUnits, int maxBytesToRead)
| Returns true if this data contains a valid string in this encoding.

## Member Typedef Documentation

## CharType

using juce::CharPointer_UTF32::CharType = juce_wchar

## Constructors and Destructors

## CharPointer_UTF32() [1/2]

juce::CharPointer_UTF32::CharPointer_UTF32 | ( | const CharType * | rawPointer | ) |

inline explicit noexcept

Referenced by atomicSwap(), CharPointer_UTF32(), findEndOfWhitespace(), findTerminatingNull(), lengthUpTo(), operator!=(), operator+(), operator++(), operator++(), operator+=(), operator-(), operator--(), operator-=(), operator<(), operator<=(), operator=(), operator=(), operator==(), operator>(), operator>=(), and writeAll().

## CharPointer_UTF32() [2/2]

juce::CharPointer_UTF32::CharPointer_UTF32 | ( | const CharPointer_UTF32 & | other | ) |

default

References CharPointer_UTF32().

## Member Functions

## operator=() [1/2]

CharPointer_UTF32 & juce::CharPointer_UTF32::operator= | ( | const CharPointer_UTF32 & | other | ) |

default noexcept

References CharPointer_UTF32().

## operator=() [2/2]

CharPointer_UTF32 & juce::CharPointer_UTF32::operator= | ( | const CharType * | text | ) |

inline noexcept

References CharPointer_UTF32().

## operator==()

bool juce::CharPointer_UTF32::operator== | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

This is a pointer comparison, it doesn't compare the actual text.

References CharPointer_UTF32().

## operator!=()

bool juce::CharPointer_UTF32::operator!= | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

References CharPointer_UTF32().

## operator<=()

bool juce::CharPointer_UTF32::operator<= | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

References CharPointer_UTF32().

## operator<()

bool juce::CharPointer_UTF32::operator< | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

References CharPointer_UTF32().

## operator>=()

bool juce::CharPointer_UTF32::operator>= | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

References CharPointer_UTF32().

## operator>()

bool juce::CharPointer_UTF32::operator> | ( | CharPointer_UTF32 | other | ) | const

inline noexcept

References CharPointer_UTF32().

## getAddress()

CharType * juce::CharPointer_UTF32::getAddress | ( |  | ) | const

inline noexcept

Returns the address that this pointer is pointing to.

## operator const CharType *()

juce::CharPointer_UTF32::operator const CharType * | ( |  | ) | const

inline noexcept

Returns the address that this pointer is pointing to.

## isEmpty()

bool juce::CharPointer_UTF32::isEmpty | ( |  | ) | const

inline noexcept

Returns true if this pointer is pointing to a null character.

## isNotEmpty()

bool juce::CharPointer_UTF32::isNotEmpty | ( |  | ) | const

inline noexcept

Returns true if this pointer is not pointing to a null character.

## operator*()

juce_wchar juce::CharPointer_UTF32::operator* | ( |  | ) | const

inline noexcept

Returns the unicode character that this pointer is pointing to.

## operator++() [1/2]

CharPointer_UTF32 & juce::CharPointer_UTF32::operator++ | ( |  | ) |

inline noexcept

Moves this pointer along to the next character in the string.

References CharPointer_UTF32().

## operator--()

CharPointer_UTF32 & juce::CharPointer_UTF32::operator-- | ( |  | ) |

inline noexcept

Moves this pointer to the previous character in the string.

References CharPointer_UTF32().

## getAndAdvance()

juce_wchar juce::CharPointer_UTF32::getAndAdvance | ( |  | ) |

inline noexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

## operator++() [2/2]

CharPointer_UTF32 juce::CharPointer_UTF32::operator++ | ( | int |  | ) |

inline noexcept

Moves this pointer along to the next character in the string.

References CharPointer_UTF32().

## operator+=()

CharPointer_UTF32 & juce::CharPointer_UTF32::operator+= | ( | int | numToSkip | ) |

inline noexcept

Moves this pointer forwards by the specified number of characters.

References CharPointer_UTF32().

## operator-=()

CharPointer_UTF32 & juce::CharPointer_UTF32::operator-= | ( | int | numToSkip | ) |

inline noexcept

References CharPointer_UTF32().

## operator[]()

juce_wchar & juce::CharPointer_UTF32::operator[] | ( | int | characterIndex | ) | const

inline noexcept

Returns the character at a given character index from the start of the string.

## operator+()

CharPointer_UTF32 juce::CharPointer_UTF32::operator+ | ( | int | numToSkip | ) | const

inline noexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

References CharPointer_UTF32().

## operator-()

CharPointer_UTF32 juce::CharPointer_UTF32::operator- | ( | int | numToSkip | ) | const

inline noexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

References CharPointer_UTF32().

## write()

void juce::CharPointer_UTF32::write | ( | juce_wchar | charToWrite | ) |

inline noexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

## replaceChar()

void juce::CharPointer_UTF32::replaceChar | ( | juce_wchar | newChar | ) |

inline noexcept

## writeNull()

void juce::CharPointer_UTF32::writeNull | ( |  | ) | const

inline noexcept

Writes a null character to this string (leaving the pointer's position unchanged).

## length()

size_t juce::CharPointer_UTF32::length | ( |  | ) | const

inline noexcept

Returns the number of characters in this string.

Referenced by findTerminatingNull(), and sizeInBytes().

## lengthUpTo() [1/2]

size_t juce::CharPointer_UTF32::lengthUpTo | ( | size_t | maxCharsToCount | ) | const

inline noexcept

Returns the number of characters in this string, or the given value, whichever is lower.

References juce::CharacterFunctions::lengthUpTo().

## lengthUpTo() [2/2]

size_t juce::CharPointer_UTF32::lengthUpTo | ( | CharPointer_UTF32 | end | ) | const

inline noexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

References CharPointer_UTF32(), juce::end(), and juce::CharacterFunctions::lengthUpTo().

## sizeInBytes()

size_t juce::CharPointer_UTF32::sizeInBytes | ( |  | ) | const

inline noexcept

Returns the number of bytes that are used to represent this string.

This includes the terminating null character.

References length().

## getBytesRequiredFor() [1/2]

size_t juce::CharPointer_UTF32::getBytesRequiredFor | ( | juce_wchar |  | ) |

inline static noexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

## getBytesRequiredFor() [2/2]

template<class CharPointer>

size_t juce::CharPointer_UTF32::getBytesRequiredFor | ( | CharPointer | text | ) |

inline static noexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format.

The value returned does NOT include the terminating null character.

## findTerminatingNull()

CharPointer_UTF32 juce::CharPointer_UTF32::findTerminatingNull | ( |  | ) | const

inline noexcept

Returns a pointer to the null character that terminates this string.

References CharPointer_UTF32(), and length().

## writeAll() [1/2]

template<typename CharPointer>

void juce::CharPointer_UTF32::writeAll | ( | CharPointer | src | ) |

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References juce::CharacterFunctions::copyAll().

## writeAll() [2/2]

void juce::CharPointer_UTF32::writeAll | ( | CharPointer_UTF32 | src | ) |

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References CharPointer_UTF32().

## writeWithDestByteLimit()

template<typename CharPointer>

size_t juce::CharPointer_UTF32::writeWithDestByteLimit | ( | CharPointer | src,
|  | size_t | maxDestBytes )

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

References juce::CharacterFunctions::copyWithDestByteLimit().

## writeWithCharLimit()

template<typename CharPointer>

void juce::CharPointer_UTF32::writeWithCharLimit | ( | CharPointer | src,
|  | int | maxChars )

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

References juce::CharacterFunctions::copyWithCharLimit().

## compare()

template<typename CharPointer>

int juce::CharPointer_UTF32::compare | ( | CharPointer | other | ) | const

inline noexcept

Compares this string with another one.

References juce::CharacterFunctions::compare().

## compareUpTo()

template<typename CharPointer>

int juce::CharPointer_UTF32::compareUpTo | ( | CharPointer | other,
|  | int | maxChars ) const

inline noexcept

Compares this string with another one, up to a specified number of characters.

References juce::CharacterFunctions::compareUpTo().

## compareIgnoreCase()

template<typename CharPointer>

int juce::CharPointer_UTF32::compareIgnoreCase | ( | CharPointer | other | ) | const

inline

Compares this string with another one.

References juce::CharacterFunctions::compareIgnoreCase().

## compareIgnoreCaseUpTo()

template<typename CharPointer>

int juce::CharPointer_UTF32::compareIgnoreCaseUpTo | ( | CharPointer | other,
|  | int | maxChars ) const

inline noexcept

Compares this string with another one, up to a specified number of characters.

References juce::CharacterFunctions::compareIgnoreCaseUpTo().

## indexOf() [1/3]

template<typename CharPointer>

int juce::CharPointer_UTF32::indexOf | ( | CharPointer | stringToFind | ) | const

inline noexcept

Returns the character index of a substring, or -1 if it isn't found.

References juce::CharacterFunctions::indexOf().

## indexOf() [2/3]

int juce::CharPointer_UTF32::indexOf | ( | juce_wchar | charToFind | ) | const

inline noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

## indexOf() [3/3]

int juce::CharPointer_UTF32::indexOf | ( | juce_wchar | charToFind,
|  | bool | ignoreCase ) const

inline noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References juce::CharacterFunctions::indexOfChar(), and juce::CharacterFunctions::indexOfCharIgnoreCase().

## isWhitespace()

bool juce::CharPointer_UTF32::isWhitespace | ( |  | ) | const

inline

Returns true if the first character of this string is whitespace.

References juce::CharacterFunctions::isWhitespace().

## isDigit()

bool juce::CharPointer_UTF32::isDigit | ( |  | ) | const

inline

Returns true if the first character of this string is a digit.

References juce::CharacterFunctions::isDigit().

## isLetter()

bool juce::CharPointer_UTF32::isLetter | ( |  | ) | const

inline

Returns true if the first character of this string is a letter.

References juce::CharacterFunctions::isLetter().

## isLetterOrDigit()

bool juce::CharPointer_UTF32::isLetterOrDigit | ( |  | ) | const

inline

Returns true if the first character of this string is a letter or digit.

References juce::CharacterFunctions::isLetterOrDigit().

## isUpperCase()

bool juce::CharPointer_UTF32::isUpperCase | ( |  | ) | const

inline

Returns true if the first character of this string is upper-case.

References juce::CharacterFunctions::isUpperCase().

## isLowerCase()

bool juce::CharPointer_UTF32::isLowerCase | ( |  | ) | const

inline

Returns true if the first character of this string is lower-case.

References juce::CharacterFunctions::isLowerCase().

## toUpperCase()

juce_wchar juce::CharPointer_UTF32::toUpperCase | ( |  | ) | const

inline noexcept

Returns an upper-case version of the first character of this string.

References juce::CharacterFunctions::toUpperCase().

## toLowerCase()

juce_wchar juce::CharPointer_UTF32::toLowerCase | ( |  | ) | const

inline noexcept

Returns a lower-case version of the first character of this string.

References juce::CharacterFunctions::toLowerCase().

## getIntValue32()

int juce::CharPointer_UTF32::getIntValue32 | ( |  | ) | const

inline noexcept

Parses this string as a 32-bit integer.

References juce::CharacterFunctions::getIntValue().

## getIntValue64()

int64 juce::CharPointer_UTF32::getIntValue64 | ( |  | ) | const

inline noexcept

Parses this string as a 64-bit integer.

References juce::CharacterFunctions::getIntValue().

## getDoubleValue()

double juce::CharPointer_UTF32::getDoubleValue | ( |  | ) | const

inline noexcept

Parses this string as a floating point double.

References juce::CharacterFunctions::getDoubleValue().

## findEndOfWhitespace()

CharPointer_UTF32 juce::CharPointer_UTF32::findEndOfWhitespace | ( |  | ) | const

inline noexcept

Returns the first non-whitespace character in the string.

References CharPointer_UTF32(), and juce::CharacterFunctions::findEndOfWhitespace().

## incrementToEndOfWhitespace()

void juce::CharPointer_UTF32::incrementToEndOfWhitespace | ( |  | ) |

inline noexcept

Move this pointer to the first non-whitespace character in the string.

References juce::CharacterFunctions::incrementToEndOfWhitespace().

## canRepresent()

bool juce::CharPointer_UTF32::canRepresent | ( | juce_wchar | character | ) |

inline static noexcept

Returns true if the given unicode character can be represented in this encoding.

References juce::CharacterFunctions::isNonSurrogateCodePoint().

Referenced by isValidString().

## isValidString()

bool juce::CharPointer_UTF32::isValidString | ( | const CharType * | codeUnits,
|  | int | maxBytesToRead )

inline static

Returns true if this data contains a valid string in this encoding.

References canRepresent().

## atomicSwap()

CharPointer_UTF32 juce::CharPointer_UTF32::atomicSwap | ( | CharPointer_UTF32 | newValue | ) |

inline

Atomically swaps this pointer for a new value, returning the previous value.

References CharPointer_UTF32().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited